from edge import eventlog
from edge.com import fs
from edge.types import JnodeError
from ..types import LandmarkServiceArgs


class JsonLandmarkServiceArgs(LandmarkServiceArgs):
    def __init__(self, *args, **kwargs):
        LandmarkServiceArgs.__init__(self, *args, **kwargs)

    @staticmethod
    def deserialize(camera_conf_jnode_path, location_jnode_path):
        """
        :type camera_conf_jnode_path: str
        :type location_jnode_path: str
        :rtype: JsonLandmarkServiceArgs | None
        :raises JnodeError:
        """
        camera_conf_jnode = fs.load_json3(camera_conf_jnode_path, default=None)

        intrinsic_jnode = camera_conf_jnode.get('ro', {}).get('intrinsic') or \
                          camera_conf_jnode.get('rw', {}).get('conf', {}).get('intrinsic') or \
                          dict()

        if not intrinsic_jnode.get('active', True):
            return None

        return JsonLandmarkServiceArgs(
            camera_conf_jnode_path,
            location_jnode_path)
